diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 0bf8f34dec5..00763269c36 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -582,23 +582,25 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
     /* Count number of available axes - supported Axis & POVs */
     for (i = 0; i < ABS_MAX; i++)
     {
-        if (idx < WINE_JOYSTICK_MAX_AXES && i < ABS_HAT0X && test_bit(This->joydev->absbits, i))
+        if ((idx = This->joydev->dev_axes_to_di[i]) >= 0)
         {
             props[idx].lDevMin = This->joydev->axes[i].minimum;
             props[idx].lDevMax = This->joydev->axes[i].maximum;
-            idx++;
         }
     }
 
     for (i = 0; i < WINE_JOYSTICK_MAX_POVS; i++)
     {
-        if (test_bit(This->joydev->absbits, ABS_HAT0X + i * 2) && test_bit(This->joydev->absbits, ABS_HAT0Y + i * 2))
+        if ((idx = This->joydev->dev_axes_to_di[ABS_HAT0X + i * 2]) >= 0)
         {
             props[idx].lDevMin = This->joydev->axes[ABS_HAT0X + i * 2].minimum;
             props[idx].lDevMax = This->joydev->axes[ABS_HAT0X + i * 2].maximum;
-            props[idx + 1].lDevMin = This->joydev->axes[ABS_HAT0Y + i * 2].minimum;
-            props[idx + 1].lDevMax = This->joydev->axes[ABS_HAT0Y + i * 2].maximum;
-            idx += 2;
+        }
+
+        if ((idx = This->joydev->dev_axes_to_di[ABS_HAT0Y + i * 2]) >= 0)
+        {
+            props[idx].lDevMin = This->joydev->axes[ABS_HAT0Y + i * 2].minimum;
+            props[idx].lDevMax = This->joydev->axes[ABS_HAT0Y + i * 2].maximum;
         }
     }
 
@@ -627,11 +629,6 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
             i++; /* POV takes 2 axes */
         }
 
-        props[idx].lMin = 0;
-        props[idx].lMax = 0xffff;
-        props[idx].lSaturation = 0;
-        props[idx].lDeadZone = This->generic.deadzone;
-
         /* Linux supports force-feedback on X & Y axes only */
         if (This->joydev->has_ff && (i == 0 || i == 1)) df->rgodf[idx].dwFlags |= DIDOI_FFACTUATOR;
 
@@ -850,7 +847,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
 
             inst_id = axis < 8 ?  DIDFT_MAKEINSTANCE(axis) | DIDFT_ABSAXIS :
                                   DIDFT_MAKEINSTANCE(axis - 8) | DIDFT_POV;
-            value = joystick_map_axis(&This->generic.props[id_to_object(This->generic.base.data_format.wine_df, inst_id)], ie.value);
+            value = joystick_map_axis(&This->generic.props[This->joydev->dev_axes_to_di[ie.code]], ie.value);
 
 	    switch (axis) {
             case 0: This->generic.js.lX  = value; break;
-- 
2.28.0

>From df697c7a93bc0a702de738fec5c673ba0ba26b55 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Tue, 6 Oct 2020 15:09:11 +0200
Subject: [PATCH 28/39] dinput: Factor unix joystick dataformat initialization.

Using ObjProps to provide types and flags.
---
 dlls/dinput/device_private.h      |   2 +
 dlls/dinput/joystick.c            |  39 +++++++-
 dlls/dinput/joystick_linux.c      |  46 ++--------
 dlls/dinput/joystick_linuxinput.c |  69 +++++---------
 dlls/dinput/joystick_osx.c        | 147 +++++++++++++-----------------
 dlls/dinput/joystick_private.h    |   2 +-
 6 files changed, 136 insertions(+), 169 deletions(-)

diff --git a/dlls/dinput/device_private.h b/dlls/dinput/device_private.h
index 3cc6eeecb91..ef6bb05108f 100644
--- a/dlls/dinput/device_private.h
+++ b/dlls/dinput/device_private.h
@@ -114,6 +114,8 @@ typedef struct
     LONG lMax;
     LONG lDeadZone;
     LONG lSaturation;
+    DWORD dwType;
+    DWORD dwFlags;
 } ObjProps;
 
 extern DWORD joystick_map_pov(const POINTL *p) DECLSPEC_HIDDEN;
diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index faefe593354..29738820e6e 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -1192,9 +1192,12 @@ HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectI
 {
     JoystickGenericImpl *This;
     ObjProps props[MAX_PROPS];
+    DIOBJECTDATAFORMAT *odf = NULL;
+    DIDATAFORMAT *df = NULL;
     HRESULT hr;
     const int *default_axes_map;
-    int i, default_axis_count;
+    int i, j, default_axis_count, prop_count;
+    WORD idx, type;
 
     if (FAILED(hr = device->create_unix_joystick(dinput, guid, &This)))
         return hr;
@@ -1212,11 +1215,41 @@ HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectI
         props[i].lMax = 0xffff;
         props[i].lDeadZone = This->deadzone;
         props[i].lSaturation = 0;
+        props[i].dwType = 0;
+        props[i].dwFlags = 0;
     }
 
-    if (FAILED(hr = This->unix_funcs->init(This->unix_ptr, props))) goto done;
+    if (FAILED(hr = This->unix_funcs->init(This->unix_ptr, props, &prop_count))) goto done;
     memcpy(This->props, props, sizeof(This->props));
 
+    if (!(df = HeapAlloc(GetProcessHeap(), 0, c_dfDIJoystick2.dwSize))) goto done;
+    memcpy(df, &c_dfDIJoystick2, c_dfDIJoystick2.dwSize);
+    if (!(odf = HeapAlloc(GetProcessHeap(), 0, df->dwNumObjs * df->dwObjSize))) goto done;
+
+    for (i = 0, j = 0; i < prop_count; ++i)
+    {
+       idx = DIDFT_GETINSTANCE(props[i].dwType);
+       type = DIDFT_GETTYPE(props[i].dwType);
+       if (!type) continue;
+
+       if (type == DIDFT_ABSAXIS)
+           memcpy(&odf[j], &c_dfDIJoystick2.rgodf[idx], df->dwObjSize);
+       else if (type == DIDFT_POV)
+           memcpy(&odf[j], &c_dfDIJoystick2.rgodf[idx + 8], df->dwObjSize);
+       else if (type == DIDFT_PSHBUTTON)
+       {
+           memcpy(&odf[j], &c_dfDIJoystick2.rgodf[idx + 12], df->dwObjSize);
+           odf[j].pguid = &GUID_Button;
+       }
+       odf[j].dwType = props[i].dwType;
+       odf[j].dwFlags |= props[i].dwFlags;
+       j++;
+       if (type == DIDFT_POV) i++; /* POV takes 2 axes */
+    }
+    df->dwNumObjs = j;
+    df->rgodf = odf;
+    This->base.data_format.wine_df = df;
+
     if (This->unix_funcs->reset) This->unix_funcs->reset(This->unix_ptr);
     if (FAILED(hr = IDirectInputDevice8_QueryInterface(IDirectInputDevice8W_from_impl(This), iid, out))) goto done;
 
@@ -1226,5 +1259,7 @@ HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectI
 done:
     /* IDirectInputDevice8_QueryInterface increased refcount */
     IDirectInputDevice8_Release(IDirectInputDevice8W_from_impl(This));
+    if (FAILED(hr) && odf) HeapFree(GetProcessHeap(), 0, odf);
+    if (FAILED(hr) && df) HeapFree(GetProcessHeap(), 0, df);
     return hr;
 }
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index b4b7b36bce6..a42767895dc 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -138,7 +138,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr);
 static HRESULT CDECL unix_joystick_acquire(struct unix_joystick *ptr);
 static HRESULT CDECL unix_joystick_unacquire(struct unix_joystick *ptr);
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props);
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count);
 static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis_count, const int **axes_map);
 
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
@@ -508,12 +508,10 @@ static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis
     *axes_map = This->joydev->axes_map;
 }
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props)
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
-    LPDIDATAFORMAT df = NULL;
-    HRESULT hr;
-    DWORD i, idx = 0;
+    int i, idx = 0, wine_obj;
 
     This->generic.devcaps.dwButtons = This->joydev->button_count;
 
@@ -523,36 +521,19 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
         This->generic.devcaps.dwButtons = 128;
     }
 
-    /* Create copy of default data format */
-    hr = DIERR_OUTOFMEMORY;
-    if (!(df = HeapAlloc(GetProcessHeap(), 0, c_dfDIJoystick2.dwSize))) goto failed;
-    memcpy(df, &c_dfDIJoystick2, c_dfDIJoystick2.dwSize);
-
-    df->dwNumObjs = This->generic.devcaps.dwAxes + This->generic.devcaps.dwPOVs + This->generic.devcaps.dwButtons;
-    if (!(df->rgodf = HeapAlloc(GetProcessHeap(), 0, df->dwNumObjs * df->dwObjSize))) goto failed;
-
     for (i = 0; i < This->joydev->axis_count; i++)
     {
-        int wine_obj = This->generic.axis_map[i];
-
-        if (wine_obj < 0) continue;
-
-        memcpy(&df->rgodf[idx], &c_dfDIJoystick2.rgodf[wine_obj], df->dwObjSize);
-        if (wine_obj < 8)
-            df->rgodf[idx++].dwType = DIDFT_MAKEINSTANCE(wine_obj) | DIDFT_ABSAXIS;
-        else
+        if ((idx = This->joydev->axes_map[i]) >= 0)
         {
-            df->rgodf[idx++].dwType = DIDFT_MAKEINSTANCE(wine_obj - 8) | DIDFT_POV;
-            i++; /* POV takes 2 axes */
+            wine_obj = This->generic.axis_map[i];
+            if (wine_obj < 0) props[idx].dwType = 0;
+            else if (wine_obj < 8) props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj) | DIDFT_ABSAXIS;
+            else props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj - 8) | DIDFT_POV;
         }
     }
     for (i = 0; i < This->generic.devcaps.dwButtons; i++)
-    {
-        memcpy(&df->rgodf[idx], &c_dfDIJoystick2.rgodf[i + 12], df->dwObjSize);
-        df->rgodf[idx  ].pguid = &GUID_Button;
-        df->rgodf[idx++].dwType = DIDFT_MAKEINSTANCE(i) | DIDFT_PSHBUTTON;
-    }
-    This->generic.base.data_format.wine_df = df;
+        props[i + 12].dwType = DIDFT_MAKEINSTANCE(i) | DIDFT_PSHBUTTON;
+    *prop_count = i + 12;
 
     This->generic.devcaps.dwSize = sizeof(This->generic.devcaps);
     This->generic.devcaps.dwFlags = DIDC_ATTACHED;
@@ -570,13 +551,6 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
     }
 
     return DI_OK;
-
-failed:
-    if (df) HeapFree(GetProcessHeap(), 0, df->rgodf);
-    HeapFree(GetProcessHeap(), 0, df);
-    release_DataFormat(&This->generic.base.data_format);
-    HeapFree(GetProcessHeap(), 0, This->generic.axis_map);
-    return hr;
 }
 
 #undef MAX_JOYSTICKS
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 00763269c36..152aa1a6934 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -172,7 +172,7 @@ static HRESULT CDECL unix_joystick_get_effect_info(struct unix_joystick *ptr, RE
 static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *effect,
         struct list *entry, IDirectInputEffect **out);
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props);
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count);
 static void CDECL unix_joystick_reset(struct unix_joystick *ptr);
 static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis_count, const int **axes_map);
 
@@ -560,12 +560,10 @@ static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis
     *axes_map = This->joydev->axes_map;
 }
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props)
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
-    LPDIDATAFORMAT df = NULL;
-    HRESULT hr;
-    int i, idx = 0;
+    int i, idx = 0, wine_obj;
 
     list_init(&This->generic.ff_effects);
 #ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
@@ -586,6 +584,13 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
         {
             props[idx].lDevMin = This->joydev->axes[i].minimum;
             props[idx].lDevMax = This->joydev->axes[i].maximum;
+
+            wine_obj = This->generic.axis_map[idx];
+            if (wine_obj < 0) props[idx].dwType = 0;
+            else if (wine_obj < 8) props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj) | DIDFT_ABSAXIS;
+            else props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj - 8) | DIDFT_POV;
+
+            if (This->joydev->has_ff && (idx == 0 || idx == 1)) props[idx].dwFlags |= DIDOI_FFACTUATOR;
         }
     }
 
@@ -595,55 +600,29 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
         {
             props[idx].lDevMin = This->joydev->axes[ABS_HAT0X + i * 2].minimum;
             props[idx].lDevMax = This->joydev->axes[ABS_HAT0X + i * 2].maximum;
+
+            wine_obj = This->generic.axis_map[idx];
+            if (wine_obj < 0) props[idx].dwType = 0;
+            else if (wine_obj < 8) props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj) | DIDFT_ABSAXIS;
+            else props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj - 8) | DIDFT_POV;
         }
 
         if ((idx = This->joydev->dev_axes_to_di[ABS_HAT0Y + i * 2]) >= 0)
         {
             props[idx].lDevMin = This->joydev->axes[ABS_HAT0Y + i * 2].minimum;
             props[idx].lDevMax = This->joydev->axes[ABS_HAT0Y + i * 2].maximum;
-        }
-    }
-
-    /* Create copy of default data format */
-    hr = DIERR_OUTOFMEMORY;
-    if (!(df = HeapAlloc(GetProcessHeap(), 0, c_dfDIJoystick2.dwSize))) goto failed;
-    memcpy(df, &c_dfDIJoystick2, c_dfDIJoystick2.dwSize);
-    if (!(df->rgodf = HeapAlloc(GetProcessHeap(), 0, df->dwNumObjs * df->dwObjSize))) goto failed;
-
 
-    /* Construct internal data format */
-
-    /* Supported Axis & POVs */
-    for (i = 0, idx = 0; i < This->joydev->axis_count; i++)
-    {
-        int wine_obj = This->generic.axis_map[i];
-
-        if (wine_obj < 0) continue;
-
-        memcpy(&df->rgodf[idx], &c_dfDIJoystick2.rgodf[wine_obj], df->dwObjSize);
-        if (wine_obj < 8)
-            df->rgodf[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj) | DIDFT_ABSAXIS;
-        else
-        {
-            df->rgodf[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj - 8) | DIDFT_POV;
-            i++; /* POV takes 2 axes */
+            wine_obj = This->generic.axis_map[idx];
+            if (wine_obj < 0) props[idx].dwType = 0;
+            else if (wine_obj < 8) props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj) | DIDFT_ABSAXIS;
+            else props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj - 8) | DIDFT_POV;
         }
-
-        /* Linux supports force-feedback on X & Y axes only */
-        if (This->joydev->has_ff && (i == 0 || i == 1)) df->rgodf[idx].dwFlags |= DIDOI_FFACTUATOR;
-
-        idx++;
     }
 
     for (i = 0; i < This->joydev->button_count; i++)
-    {
-        memcpy(&df->rgodf[idx], &c_dfDIJoystick2.rgodf[i + 12], df->dwObjSize);
-        df->rgodf[idx  ].pguid = &GUID_Button;
-        df->rgodf[idx++].dwType = DIDFT_MAKEINSTANCE(i) | DIDFT_PSHBUTTON;
-    }
-    df->dwNumObjs = idx;
+        props[i + 12].dwType = DIDFT_MAKEINSTANCE(i) | DIDFT_PSHBUTTON;
+    *prop_count = i + 12;
     This->generic.devcaps.dwButtons = This->joydev->button_count;
-    This->generic.base.data_format.wine_df = df;
 
     /* Fill the caps */
     This->generic.devcaps.dwSize = sizeof(This->generic.devcaps);
@@ -653,12 +632,6 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
     if (This->joydev->has_ff) This->generic.devcaps.dwFlags |= DIDC_FORCEFEEDBACK;
 
     return DI_OK;
-
-failed:
-    if (df) HeapFree(GetProcessHeap(), 0, df->rgodf);
-    HeapFree(GetProcessHeap(), 0, df);
-    HeapFree(GetProcessHeap(), 0, This->generic.axis_map);
-    return hr;
 }
 
 const struct dinput_device joystick_linuxinput_device = {
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index 0a1724181bc..380d52a52ad 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -744,8 +744,14 @@ static void get_osx_device_elements(JoystickImpl *device, int axis_map[8])
     }
 }
 
-static void get_osx_device_elements_props(JoystickImpl *device, ObjProps *props)
+static BOOL osx_axis_has_ff(FFCAPABILITIES *ffcaps, UInt8 axis);
+
+static void get_osx_device_elements_props(JoystickImpl *device, FFCAPABILITIES *ffcaps, ObjProps *props, int *prop_count)
 {
+    int button_idx = 0;
+    int pov_idx = 0;
+    int slider_idx = 0;
+
     TRACE("device %p\n", device);
 
     if (device->elements)
@@ -755,13 +761,68 @@ static void get_osx_device_elements_props(JoystickImpl *device, ObjProps *props)
         for ( idx = 0; idx < cnt; idx++ )
         {
             IOHIDElementRef element = ( IOHIDElementRef ) CFArrayGetValueAtIndex( device->elements, idx );
+            int type = IOHIDElementGetType( element );
 
             TRACE("element %s\n", debugstr_element(element));
 
             props[idx].lDevMin = IOHIDElementGetLogicalMin(element);
             props[idx].lDevMax = IOHIDElementGetLogicalMax(element);
+
+            switch(type)
+            {
+                case kIOHIDElementTypeInput_Button:
+                    if(button_idx >= 128) break;
+                    props[idx].dwType = DIDFT_MAKEINSTANCE(button_idx) | DIDFT_PSHBUTTON;
+                    button_idx++;
+                    break;
+                case kIOHIDElementTypeInput_Misc:
+                {
+                    uint32_t usage = IOHIDElementGetUsage( element );
+                    switch(usage)
+                    {
+                        case kHIDUsage_GD_Hatswitch:
+                            props[idx].dwType = DIDFT_MAKEINSTANCE(pov_idx) | DIDFT_POV;
+                            pov_idx++;
+                            break;
+                        case kHIDUsage_GD_X:
+                            props[idx].dwType = DIDFT_MAKEINSTANCE(0) | DIDFT_ABSAXIS;
+                            if ((device->ff != 0) && osx_axis_has_ff(ffcaps, FFJOFS_X)) props[idx].dwFlags |= DIDOI_FFACTUATOR;
+                            break;
+                        case kHIDUsage_GD_Y:
+                            props[idx].dwType = DIDFT_MAKEINSTANCE(1) | DIDFT_ABSAXIS;
+                            if ((device->ff != 0) && osx_axis_has_ff(ffcaps, FFJOFS_Y)) props[idx].dwFlags |= DIDOI_FFACTUATOR;
+                            break;
+                        case kHIDUsage_GD_Z:
+                            props[idx].dwType = DIDFT_MAKEINSTANCE(2) | DIDFT_ABSAXIS;
+                            if ((device->ff != 0) && osx_axis_has_ff(ffcaps, FFJOFS_Z)) props[idx].dwFlags |= DIDOI_FFACTUATOR;
+                            break;
+                        case kHIDUsage_GD_Rx:
+                            props[idx].dwType = DIDFT_MAKEINSTANCE(3) | DIDFT_ABSAXIS;
+                            if ((device->ff != 0) && osx_axis_has_ff(ffcaps, FFJOFS_RX)) props[idx].dwFlags |= DIDOI_FFACTUATOR;
+                            break;
+                        case kHIDUsage_GD_Ry:
+                            props[idx].dwType = DIDFT_MAKEINSTANCE(4) | DIDFT_ABSAXIS;
+                            if ((device->ff != 0) && osx_axis_has_ff(ffcaps, FFJOFS_RY)) props[idx].dwFlags |= DIDOI_FFACTUATOR;
+                            break;
+                        case kHIDUsage_GD_Rz:
+                            props[idx].dwType = DIDFT_MAKEINSTANCE(5) | DIDFT_ABSAXIS;
+                            if ((device->ff != 0) && osx_axis_has_ff(ffcaps, FFJOFS_RZ)) props[idx].dwFlags |= DIDOI_FFACTUATOR;
+                            break;
+                        case kHIDUsage_GD_Slider:
+                            props[idx].dwType = DIDFT_MAKEINSTANCE(6 + slider_idx) | DIDFT_ABSAXIS;
+                            if ((device->ff != 0) && osx_axis_has_ff(ffcaps, FFJOFS_SLIDER(slider_idx))) props[idx].dwFlags |= DIDOI_FFACTUATOR;
+                            slider_idx++;
+                            break;
+                        default:
+                            break;
+                    }
+                    break;
+                }
+            }
         }
+        *prop_count = idx;
     }
+    else *prop_count = 0;
 }
 
 static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
@@ -944,7 +1005,7 @@ static HRESULT CDECL unix_joystick_ff_send_cmd(struct unix_joystick *ptr, DWORD
 static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *params,
         struct list *entry, IDirectInputEffect **out);
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props);
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count);
 
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
@@ -1133,18 +1194,15 @@ static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID gui
     return DI_OK;
 }
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props)
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
     IOHIDDeviceRef device;
-    LPDIDATAFORMAT df = NULL;
     FFCAPABILITIES ffcaps;
     char name[MAX_PATH];
     HRESULT hr;
     DWORD i;
-    int idx = 0;
     int axis_map[8]; /* max axes */
-    int slider_count = 0;
 
     device = get_device_ref(This->id);
 
@@ -1196,74 +1254,8 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
         This->generic.devcaps.dwButtons = 128;
     }
 
-    /* Create copy of default data format */
-    if (!(df = HeapAlloc(GetProcessHeap(), 0, c_dfDIJoystick2.dwSize))) goto FAILED;
-    memcpy(df, &c_dfDIJoystick2, c_dfDIJoystick2.dwSize);
-
-    df->dwNumObjs = This->generic.devcaps.dwAxes + This->generic.devcaps.dwPOVs + This->generic.devcaps.dwButtons;
-    if (!(df->rgodf = HeapAlloc(GetProcessHeap(), 0, df->dwNumObjs * df->dwObjSize))) goto FAILED;
-
-    for (i = 0; i < This->generic.devcaps.dwAxes; i++)
-    {
-        int wine_obj = -1;
-        BOOL has_ff  = FALSE;
-        switch (axis_map[i])
-        {
-            case kHIDUsage_GD_X:
-                wine_obj = 0;
-                has_ff = (This->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_X);
-                break;
-            case kHIDUsage_GD_Y:
-                wine_obj = 1;
-                has_ff = (This->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_Y);
-                break;
-            case kHIDUsage_GD_Z:
-                wine_obj = 2;
-                has_ff = (This->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_Z);
-                break;
-            case kHIDUsage_GD_Rx:
-                wine_obj = 3;
-                has_ff = (This->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_RX);
-                break;
-            case kHIDUsage_GD_Ry:
-                wine_obj = 4;
-                has_ff = (This->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_RY);
-                break;
-            case kHIDUsage_GD_Rz:
-                wine_obj = 5;
-                has_ff = (This->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_RZ);
-                break;
-            case kHIDUsage_GD_Slider:
-                wine_obj = 6 + slider_count;
-                has_ff = (This->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_SLIDER(slider_count));
-                slider_count++;
-                break;
-        }
-        if (wine_obj < 0 ) continue;
-
-        memcpy(&df->rgodf[idx], &c_dfDIJoystick2.rgodf[wine_obj], df->dwObjSize);
-        df->rgodf[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj) | DIDFT_ABSAXIS;
-        if(has_ff)
-            df->rgodf[idx].dwFlags |= DIDOI_FFACTUATOR;
-        ++idx;
-    }
-
-    for (i = 0; i < This->generic.devcaps.dwPOVs; i++)
-    {
-        memcpy(&df->rgodf[idx], &c_dfDIJoystick2.rgodf[i + 8], df->dwObjSize);
-        df->rgodf[idx++].dwType = DIDFT_MAKEINSTANCE(i) | DIDFT_POV;
-    }
-
-    for (i = 0; i < This->generic.devcaps.dwButtons; i++)
-    {
-        memcpy(&df->rgodf[idx], &c_dfDIJoystick2.rgodf[i + 12], df->dwObjSize);
-        df->rgodf[idx  ].pguid = &GUID_Button;
-        df->rgodf[idx++].dwType = DIDFT_MAKEINSTANCE(i) | DIDFT_PSHBUTTON;
-    }
-    This->generic.base.data_format.wine_df = df;
-
     /* initialize default properties */
-    get_osx_device_elements_props(This, props);
+    get_osx_device_elements_props(This, &ffcaps, props, prop_count);
 
     This->generic.devcaps.dwSize = sizeof(This->generic.devcaps);
     This->generic.devcaps.dwFlags |= DIDC_ATTACHED;
@@ -1280,15 +1272,6 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
     }
 
     return DI_OK;
-
-FAILED:
-    hr = DIERR_OUTOFMEMORY;
-    if (This->ff) FFReleaseDevice(This->ff);
-    if (This->elements) CFRelease(This->elements);
-    if (df) HeapFree(GetProcessHeap(), 0, df->rgodf);
-    HeapFree(GetProcessHeap(), 0, df);
-    release_DataFormat(&This->generic.base.data_format);
-    return hr;
 }
 
 static HRESULT CDECL unix_joystick_ff_set_autocenter(struct unix_joystick *ptr, DWORD value)
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index 536b77b3ea2..6fe1bfce0a9 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -37,7 +37,7 @@ struct unix_joystick;
 
 struct unix_joystick_vtbl
 {
-    HRESULT (CDECL *init)(struct unix_joystick *ptr, ObjProps *props);
+    HRESULT (CDECL *init)(struct unix_joystick *ptr, ObjProps *props, int *prop_count);
     void (CDECL *reset)(struct unix_joystick *ptr);
 
     void (CDECL *get_mapping)(struct unix_joystick *ptr, int *axis_count, const int **axes_map);
-- 
2.28.0

>From 0e26d6a8bd9f6b3423cde595523edf54f46754f1 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Tue, 6 Oct 2020 16:07:43 +0200
Subject: [PATCH 29/39] dinput: Factor unix joystick devcaps initialization.

---
 dlls/dinput/joystick.c            | 37 +++++++++++++++++++++---
 dlls/dinput/joystick_linux.c      | 38 ++++++++-----------------
 dlls/dinput/joystick_linuxinput.c | 15 ++--------
 dlls/dinput/joystick_osx.c        | 47 ++++---------------------------
 dlls/dinput/joystick_private.h    |  4 +--
 5 files changed, 54 insertions(+), 87 deletions(-)

diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index 29738820e6e..de30e0aa073 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -521,7 +521,7 @@ HRESULT WINAPI JoystickWGenericImpl_Unacquire(LPDIRECTINPUTDEVICE8W iface)
 }
 
 #define DEBUG_TYPE(x) case (x): str = #x; break
-void _dump_DIDEVCAPS(const DIDEVCAPS *lpDIDevCaps)
+static void _dump_DIDEVCAPS(const DIDEVCAPS *lpDIDevCaps)
 {
     int type = GET_DIDEVICE_TYPE(lpDIDevCaps->dwDevType);
     const char *str, *hid = "";
@@ -1198,6 +1198,7 @@ HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectI
     const int *default_axes_map;
     int i, j, default_axis_count, prop_count;
     WORD idx, type;
+    BOOL has_ff = FALSE;
 
     if (FAILED(hr = device->create_unix_joystick(dinput, guid, &This)))
         return hr;
@@ -1219,7 +1220,12 @@ HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectI
         props[i].dwFlags = 0;
     }
 
-    if (FAILED(hr = This->unix_funcs->init(This->unix_ptr, props, &prop_count))) goto done;
+    memset(&This->devcaps, 0, sizeof(This->devcaps));
+    This->devcaps.dwSize = sizeof(This->devcaps);
+    This->devcaps.dwFlags = DIDC_ATTACHED;
+    This->devcaps.dwDevType = This->base.info.dwDevType;
+
+    if (FAILED(hr = This->unix_funcs->init(This->unix_ptr, props, &prop_count, &has_ff))) goto done;
     memcpy(This->props, props, sizeof(This->props));
 
     if (!(df = HeapAlloc(GetProcessHeap(), 0, c_dfDIJoystick2.dwSize))) goto done;
@@ -1233,13 +1239,20 @@ HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectI
        if (!type) continue;
 
        if (type == DIDFT_ABSAXIS)
+       {
            memcpy(&odf[j], &c_dfDIJoystick2.rgodf[idx], df->dwObjSize);
+           This->devcaps.dwAxes++;
+       }
        else if (type == DIDFT_POV)
+       {
            memcpy(&odf[j], &c_dfDIJoystick2.rgodf[idx + 8], df->dwObjSize);
+           This->devcaps.dwPOVs++;
+       }
        else if (type == DIDFT_PSHBUTTON)
        {
            memcpy(&odf[j], &c_dfDIJoystick2.rgodf[idx + 12], df->dwObjSize);
            odf[j].pguid = &GUID_Button;
+           This->devcaps.dwButtons++;
        }
        odf[j].dwType = props[i].dwType;
        odf[j].dwFlags |= props[i].dwFlags;
@@ -1250,11 +1263,27 @@ HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectI
     df->rgodf = odf;
     This->base.data_format.wine_df = df;
 
+    if (has_ff)
+    {
+        DIPROPDWORD prop = {};
+        This->devcaps.dwFlags |= DIDC_FORCEFEEDBACK;
+        prop.diph.dwSize = sizeof(prop);
+        prop.dwData = 10000;
+        JoystickWGenericImpl_SetProperty(IDirectInputDevice8W_from_impl(This), DIPROP_FFGAIN, &prop.diph);
+        prop.diph.dwSize = sizeof(prop);
+        prop.dwData = DIPROPAUTOCENTER_ON;
+        JoystickWGenericImpl_SetProperty(IDirectInputDevice8W_from_impl(This), DIPROP_AUTOCENTER, &prop.diph);
+    }
+
     if (This->unix_funcs->reset) This->unix_funcs->reset(This->unix_ptr);
     if (FAILED(hr = IDirectInputDevice8_QueryInterface(IDirectInputDevice8W_from_impl(This), iid, out))) goto done;
 
-    TRACE("created unix joystick %p\n", This);
-    if (TRACE_ON(dinput)) _dump_DIDATAFORMAT(This->base.data_format.wine_df);
+    if (TRACE_ON(dinput))
+    {
+        TRACE("created unix joystick %p\n", This);
+        _dump_DIDEVCAPS(&This->devcaps);
+        _dump_DIDATAFORMAT(This->base.data_format.wine_df);
+    }
 
 done:
     /* IDirectInputDevice8_QueryInterface increased refcount */
